#include "clihandler.h"
#include "host.h"
#include "world.h"
#include "log.h"
using namespace std;
using namespace net;

static char version = 1;

static void idle(char*, Socket)
{
    
}

static void login(char *data, Socket socket)
{
    out << "Connection data: " << (int)*data << "\n";
    
    if(*data == 1) {
        
        out << "Connected sucesfully!\n";
        host.loginStatus = 1;
    }
    else {
        
        out << "Connection failed.\n";
        host.loginStatus = -1;
    }
    
    char message[2];
    
    message[0] = 7;
    message[1] = version;
    
    socket.send(message, sizeof(message));
}

static void statresponse(char *data, Socket socket)
{
    host.statusResponse = ntohl(*(int*)data);
    
    out << "Status: " << host.statusResponse << "\n";
}

static void getitem(char *data, Socket socket)
{
    world.users[0].items[ntohl(*(unsigned int*)&data[0])] = ntohl(*(unsigned int*)&data[4]);
}

static void getcity(char *data, Socket socket)
{
    City &city = world.cities[ntohl(*(unsigned int*)&data[0])];
    
    for(int i = 0; i < 8; i++)
        city.terminals[i] = ntohl(*(unsigned int*)&data[4 + 4 * i]);
}

static void getbuilding(char *data, Socket socket)
{
    Building &building = world.buildings[ntohl(*(unsigned int*)&data[0])];
    
    building.type = ntohl(*(unsigned int*)&data[4]);
    building.x = ntohl(*(int*)&data[8]);
    building.y = ntohl(*(int*)&data[12]);
    building.player = ntohl(*(unsigned int*)&data[16]);
    building.track = ntohl(*(unsigned int*)&data[18]);
    
    out << "New building at " << ntohl(*(unsigned int*)&data[0]) << "\n";
}

static void removebuilding(char *data, Socket socket)
{
    world.buildings.erase(ntohl(*(unsigned int*)data));
    
    out << "erased it.\n";
}

static ofstream updater;

static void beginupdater(char *data, Socket socket)
{
    string filename(data, 64);
    
    filename = filename.c_str();
    
    updater.open(filename.c_str(), ios::out | ios::binary);
}

static void updatechunk(char *data, Socket socket)
{
    updater.write(data + 1, 256);
    
    if(*data)
        updater.close();
}

static void doupdate(char *data, Socket socket)
{
    string command(data, 64);
    
    command = command.c_str();
    
    out << "doupdate " << (int)*data << "\n";
    
    system(command.c_str());
}

int maxTag = 9;

unsigned int sizeOfData[] =
{
    0, // 0 - idle
    1, // 1 - login response (1 accepted?)
    4, // 2 - status response (4 err-code)
    8, // 3 - get item (4 item id, 4 item count)
    4 + 4 * 8, // 4 - get city (4 city id, 4 terminal id * 8)
    24, // 5 - get building (4 build id, 4 build type, 4 x, 4 y, 4 player, 4 track)
    4, // 6 - remove building (4 build id)
    64, // 7 - begin updater (64 output filename)
    1 + 256, // 8 - updater chunk (1 done flag, 256 data)
    256, // 9 - do update (256 command)
};

void (*tagHandlers[])(char*, Socket)  =
{
    idle, // 0
    login, // 1
    statresponse, // 2
    getitem, // 3
    getcity, // 4
    getbuilding, // 5
    removebuilding, // 6
    beginupdater, // 7
    updatechunk, //8
    doupdate, // 9
};
