#ifndef GUIMANAGER_H
#define GUIMANAGER_H

#include "gui.h"
#include "animation.h"
#include "guiscreen.h"
#include "host.h"
#include <string>
#include <stack>
#include <vector>
#include <list>

class GuiManager : public GuiState {
public:
    
    GuiManager();
    
    virtual ~GuiManager();
    
    // Called when it is time to draw this GuiState
    virtual void draw();
    
    // Called at a constant rate (probably 20 milliseconds between calls)
    // see gui.h for a description.
    virtual Options think(Gui &caller);
    
    // Recieves the current frames per second rate
    virtual void fps(int fps) { currentFPS = fps; }
    
private:
    
    // Checks for and handles any actions waiting in the top
    // GuiScreen's action queue.
    void handleActions();
    
    int currentFPS;
    
    std::list<GuiScreen*> screenStack;
    
    animation cursor;
    
    bool shouldClearScreen;
    
    bool quit;
};

#endif
