#ifndef GUITILEMAP_H
#define GUITILEMAP_H

#include "gui.h"
#include "animation.h"
#include "guiscreen.h"
#include "tilemap.h"
#include <string>
#include <stack>
#include <vector>
#include <list>

class GuiTilemap : public GuiState {
public:
    
    GuiTilemap();
    
    virtual ~GuiTilemap();
    
    // Called when it is time to draw this GuiState
    virtual void draw();
    
    // Called at a constant rate (probably 20 milliseconds between calls)
    // see gui.h for a description.
    virtual Options think(Gui &caller);
    
    // Recieves the current frames per second rate
    virtual void fps(int fps) { currentFPS = fps; }
    
private:
    
    // Checks for and handles any actions waiting in the top
    // GuiScreen's action queue.
    void handleActions();
    
    int currentFPS;
    int old_mouse_b;
    
    std::list<GuiScreen*> screenStack;
    
    animation cursor;
    /// GUI bitmaps
    animation handles, bg;
    
    /// Current state of cursor
    /// 0 - Normal
    /// 1 - build building
    /// 2 - build train
    /// 3 - build track
    /// 4 - in city
    int cursor_state;
    /// Index of building, if cursor_state == 1
    int building;
    
    Tilemap tiles;
    
    bool shouldClearScreen;
};

#endif
