#ifndef WIDGETS_CHECKBOX_H
#define WIDGETS_CHECKBOX_H

#include "widget.h"
#include "animation.h"
#include <string>

namespace widgets {
    
    class CheckBox : public Widget {
    public:
        
        CheckBox();
        virtual ~CheckBox() {}
        
        // Attributes can contain these keys:
        
        // Whether or not this widget is checked.  0 for unchecked, non-zero for checked
        // "checked"
        
        // Sounds that are played when the checkbox is checked or unchecked.  An empty string
        // means no sound will be played.
        // "checkSound"
        // "uncheckSound"
        
    protected:
        
        // Called when the widget needs to be drawn.  xstart and ystart are added to
        // the widget's x / y position to deduce the drawing position.
        virtual void draw(int xstart, int ystart, const Tint &tint);
        
        // The events that need to be recieved
        virtual Action onHover();
        virtual Action onLeave();
        virtual Action onClick();
        virtual Action onRelease();
        
    private:
        
        animation inactive;
        animation active;
        animation hover;
        animation checkOn;
        animation checkOff;
        
        animation *curBackground;
    };
}

#endif
