#ifndef WIDGETS_IMAGE_H
#define WIDGETS_IMAGE_H

#include "widget.h"
#include "animation.h"

namespace widgets {
    
    class Image : public Widget {
    public:
        
        virtual ~Image();
        
        // attributes can contain the following keys:
        //  "src", The location of the Image in the datafile, must end
        //         with a '/'.
        
        // Called when the widget needs to be drawn.  xstart and ystart are added to the widget's
        // x / y position to deduce the drawing position.
        virtual void draw(int xstart, int ystart, const Tint &tint);
        
        virtual void load();
        
    private:
        
        animation *anim;
    };
}

#endif
