#ifndef WIDGETS_MINIBUTTON_H
#define WIDGETS_MINIBUTTON_H

#include "widget.h"
#include "animation.h"
#include <string>

namespace widgets {
    
    class MiniButton : public Widget {
    public:
        
        MiniButton();
        virtual ~MiniButton() {}
        
        // Attributes is unused for this object
        
    protected:
        
        // Draws the button when it needs to be drawn.  xstart and ystart are added to the widget's
        // x / y position to deduce the drawing position.
        virtual void draw(int xstart, int ystart, const Tint &tint);
        
        // The events a MiniButton needs to recieve
        virtual Action onHover();
        virtual Action onLeave();
        virtual Action onClick();
        virtual Action onRelease();
        
    private:
        
        animation inactive;
        animation active;
        animation hover;
        
        animation *current;
    };
}

#endif
