#ifndef WIDGETS_PROFILESELECTOR_H
#define WIDGETS_PROFILESELECTOR_H

#include "widgets_listbox.h"

namespace widgets {
    
    class ProfileSelector : public ListBox {
    public:
        
        virtual ~ProfileSelector();
        
        // attributes can contain the following keys:
        //  none
        
        virtual void load();
        
        // Call this when you want to set curProfile to something different
        // so as to avoid memory leaks (ProfileSelector assumes you will delete
        // the curProfile it allocated, unless you call this).
        static void onCurProfileChange();
        
        // Re-reads the profiles from the harddrive to update the profile list for the
        // last ProfileSelector that load was called for.  If ProfileSelector::load
        // hasnt been called yet this function does nothing.
        static void updateLists();
    };
}

#endif
