#include <allegro.h>
#ifdef WIN32
#include <winalleg.h>
#endif
#include <iostream>
#include <string>
#include "socket.h"
#include "thread.h"
#include "mutex.h"
using namespace std;
using namespace net;

Mutex mutex;
char buf[256];
int i;

Socket *con;

int readStuff(void*)
{
    char msg[256];
    int size;
    
    for(;;) {
        
        mutex.lock();
        int room = sizeof(buf) - i;
        mutex.unlock();
        
        if(con->recv(msg, room, &size) < 1) {
            
            cout << getError() << "\n";
            return 1;
        }
        
        mutex.lock(); {
            memcpy(buf + i, msg, size);
            i += size;
        } mutex.unlock();
    }
    
    return 0;
}

int main(int argc, char *argv[])
{
    allegro_init();
    install_keyboard();
    set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0);
    
    try {
        
        Socket s(Socket::TCP);
        con = &s;
        
        if(!con->connectIp(argv[1], 1423)) {
            
            cout << getError() << "\n";
            return 1;
        }
        else
            cout << "Connected " << argv[1] << "\n";
        
        Thread t(readStuff);
        
        while(!t.done()) {
            
            char c[5] = { '\0', 'A' };
            
            if(keypressed()) {
                
                int k = readkey();
                
                for(int i = 0; i < 4; i++)
                    c[i + 1] = (k & 0xff) + i;
                
                if(!con->send(c, 5))
                    cout << getError() << "\n";
            }
            
            mutex.lock();
            cout << buf;
            mutex.unlock();
        }
    }
    catch (const char* message)
    {
        cout << message;
    }
    
    return 0;
}
END_OF_MAIN()
