#ifndef SERVHANDLER_H
#define SERVHANDLER_H

#include "socket.h"

// maintains the size of the data given an index (the tag is the index)
// Use this to lookup the size of the data chunk given a tag number
// sizeOfData[0] will always be 0
extern unsigned int sizeOfData[];

// Any tag over this value is invalid
extern int maxTag;

// array of functions for handing data given a tag number.
// the size of data is determined by the tag.  the tag referes to the index
// in this list.
// data is the data for the given tag.  socket is the socket where data can 
// be sent out again through.
//
// you must call tagHandlers[0] for every connected client in a loop.  in this
// case data is ignored and socket must be set to the client to be updated.
extern void (*tagHandlers[])(char *data, net::Socket socket);

#endif
