#include "buildings.h"
#include <log.h>
#include <fstream>
#include <sstream>
using namespace std;

void Buildings::load(const string &filename)
{
    buildings.clear();
    
    string line, str;
    
    ifstream in(filename.c_str());
    
    getline(in, line);
    
    if(line.find("buildingDb") != 0)
        throw "Invalid buildingDb file";
    
    unsigned int i = line.find("v");
    
    if(i == string::npos)
        throw "Unable to find version number in buildingDb file";
    
    int ver = 0;
    
    istringstream verss(line.substr(i));
    
    verss.ignore();
    
    verss >> ver;
    
    if(ver != 1)
        throw "Invalid version number for buildingDb file";
    
    while(in.good()) {
        
        getline(in, line);
        
        istringstream data(line);
        
        unsigned int id = 0;
        
        data >> id;
        
        if(id) {
            
            Building &building = buildings[id];
            
            data >> building.cost;
            data >> building.name;
            
            while(data.good()) {
                
                data >> str;
                building.descr += str + " ";
            }
        }
    }
    
    out << "Loaded buildingDb, buildings: " << buildings.size() << "\n";
}
