#include "byteorder.h"

bool endian::isLittle()
{
#if defined(__BIG_ENDIAN__) || defined(_BIG_ENDIAN)
    return false;
#else
    static short s = 255;
    static char *p = reinterpret_cast<char*>(&s);
    
    return p[0];
#endif
}

int32_t endian::swap_int32_t(int32_t v)
{
    return ((v >> 24) & 0xFF) | ((v >> 8) & 0xFF00) | ((v << 8) & 0xFF0000) | ((v << 24) & 0xFF000000);
}

char &endian::getByteFrom_int32_t(int32_t source, int which)
{
    if(isLittle())
        return ((char*)&source)[which];
    else
        return ((char*)&source)[3 - which];
}
