#include "log.h"
#include <iostream>
using namespace std;

Log err(cerr);
Log out(cout);

Log::Log(ostream &stream)
    : writeTimestamps(true), wroteTimestamp(false)
{
    addOutStream(stream);
}

Log::Log(const string &filename)
    : writeTimestamps(true), wroteTimestamp(false)
{
    addOutFile(filename);
}

Log::Log()
    : writeTimestamps(true), wroteTimestamp(false)
{
    
}

void Log::addOutStream(ostream &stream)
{
    outList.push_back(&stream);
}

void Log::removeOutStream(ostream &stream)
{
    if(outList.empty())
        return;
    
    // Go backwards through the vector and delete first occurance.
    // rbegin and rend aren't supported well enough to be usuable on
    // gcc at the moment.
    
    for(vector<ostream*>::iterator itr = outList.end() - 1; 1; ) {
        
        if(*itr == &stream) {
            
            outList.erase(itr);
            break;
        }
        
        if(itr == outList.begin())
            break;
    }
}

void Log::addOutFile(const string &filename)
{
    openFiles.push_front(FileInfo(filename));
}

void Log::removeOutFile(const string &filename)
{
    for(list<FileInfo>::iterator itr = openFiles.begin(); itr != openFiles.end(); ++itr)
        if(itr->name == filename) {
            
            openFiles.erase(itr);
            break;
        }
}
