#include <allegro.h>
#ifdef WIN32
#include <winalleg.h>
#endif
#include "onrelease.h"
#include "log.h"

static volatile bool anyReleased = 0;
static bool oldMouse = 0;
static void keypress_watcher(int scanecode)
{
    // Allegro sets this bit for key released events
    const int keyUp = 0x80;
    
    if(scanecode & keyUp)
        anyReleased = 1;
}

bool onRelease()
{
    static bool onetime = 1;
    bool ret = false;
    
    if(onetime) {
        
        onetime = 0;
        
        LOCK_FUNCTION(keypress_watcher);
        LOCK_VARIABLE(anyReleased);
        
        keyboard_lowlevel_callback = keypress_watcher;
    }
    
    if(anyReleased)
        ret = true;
    
    if(oldMouse && !mouse_b)
        ret = true;
    
    clearReleaseFlag();
    
    return ret;
}

void clearReleaseFlag()
{
    anyReleased = 0;
    oldMouse = mouse_b;
}
