#include "readhash.h"
#include <cctype>
using namespace std;

map<string, string> &readHash(istream &in, map<string, string> &hash)
{
    static string buf;
    
    char last = '\0';
    
    while(in.good() && isspace(in.peek()))
        in.ignore();
    
    while(!isdigit(in.peek()) && in.good()) {
        
        buf.clear();
        
        bool hasQuote = 0;
        
        while(in.good()) {
            
            if(in.peek() == '"' && last != '\\') {
                
                in.ignore();
                
                if(!hasQuote)
                    hasQuote = 1;
                else
                    break;
            }
            
            if(isspace(in.peek()) && !hasQuote)
                break;
            
            if(in.good())
                if((last = in.get()) != '\\')
                    buf += last;
        }
        
        unsigned int pos = buf.find('=');
        
        if(pos != string::npos && pos + 1 < buf.size())
            hash[buf.substr(0, pos)] = buf.substr(pos + 1);
        
        while(in.good() && isspace(in.peek()))
            in.ignore();
    }
    
    return hash;
}
