#include "widgets_button.h"
#include "print.h"
#include "sounds.h"
#include "log.h"
using namespace std;
using namespace widgets;

Button::Button(int x, int y, int w, int)
    : Widget(x, y, w, 64),
      
      inactiveLeft("GUI/BUTTON/INACTIVE/LEFT/"),
      inactiveCenter("GUI/BUTTON/INACTIVE/CENTER/"),
      inactiveRight("GUI/BUTTON/INACTIVE/RIGHT/"),
        
      activeLeft("GUI/BUTTON/ACTIVE/LEFT/"),
      activeCenter("GUI/BUTTON/ACTIVE/CENTER/"),
      activeRight("GUI/BUTTON/ACTIVE/RIGHT/"),
        
      hoverLeft("GUI/BUTTON/HOVER/LEFT/"),
      hoverCenter("GUI/BUTTON/HOVER/CENTER/"),
      hoverRight("GUI/BUTTON/HOVER/RIGHT/"),
      
      curLeft(&inactiveLeft),
      curCenter(&inactiveCenter),
      curRight(&inactiveRight)
{
    
}

void Button::draw(int xstart, int ystart, const Tint &tint)
{
    int x = xstart;
    int y = ystart;
    
    Tint temp(tint);
    
    if(isDisabled()) {
        
        curLeft = &inactiveLeft;
        curCenter = &inactiveCenter;
        curRight = &inactiveRight;
        
        temp.a *= 0.5f;
    }
    
    if(curCenter->get_bmp() && curLeft->get_bmp() && curRight->get_bmp()) {
        
        curLeft->get_bmp()->blitToScreen(x, y, temp);
        curRight->get_bmp()->blitToScreen(x + w - curRight->get_bmp()->getw(), y, temp);
        curCenter->get_bmp()->specialBlitToScreen(x + curLeft->get_bmp()->getw(), y, (w - (curLeft->get_bmp()->getw() + curRight->get_bmp()->getw())) / (float)curCenter->get_bmp()->getw(), 1, 0, temp);
        
        Print printer(x + w / 2 - Print::getFontRenderer().stringWidth(attributes["text"]) / 2, y + curCenter->get_bmp()->geth() / 2 - Print::getFontRenderer().height() / 2, temp);
        
        printer << attributes["text"];
    }
}

Button::Action Button::onHover()
{
    if(!isDisabled()) {
        
        /*curLeft = &hoverLeft;
        curCenter = &hoverCenter;
        curRight = &hoverRight;*/
    }
    
    return OK;
}

Button::Action Button::onLeave()
{
    if(!isDisabled()) {
        
        /*curLeft = &inactiveLeft;
        curCenter = &inactiveCenter;
        curRight = &inactiveRight;*/
    }
    
    return OK;
}

Button::Action Button::onClick()
{
    if(!isDisabled()) {
        
        /*curLeft = &activeLeft;
        curCenter = &activeCenter;
        curRight = &activeRight;*/
    }
    
    return OK;
}

Button::Action Button::onRelease()
{
    if(!isDisabled()) {
        
        /*curLeft = &hoverLeft;
        curCenter = &hoverCenter;
        curRight = &hoverRight;*/
        
        if(!attributes["releaseSound"].empty())
            Sounds::play(attributes["releaseSound"]);
    }
    
    return OK;
}

bool Button::isDisabled()
{
    if(attributes["special"] == "disabled")
        return true;
    
    if(attributes.count("requireAttribute"))
        return attributes[attributes["requireAttribute"]].empty();
    
    return false;
}
