#include "widgets_checkbox.h"
#include "print.h"
#include "sounds.h"
#include "log.h"
using namespace std;
using namespace widgets;

CheckBox::CheckBox()
    : inactive("GUI/MINIBUTTON/INACTIVE/"),
      active("GUI/MINIBUTTON/ACTIVE/"),
      hover("GUI/MINIBUTTON/HOVER/"),
      
      checkOn("GUI/CHECKBOX/ON/"),
      checkOff("GUI/CHECKBOX/OFF/"),
      
      curBackground(&inactive)
{
    
}

void CheckBox::draw(int xstart, int ystart, const Tint &tint)
{
    int x = this->x + xstart;
    int y = this->y + ystart;
    
    if(curBackground->get_bmp())
        curBackground->get_bmp()->blitToScreen(x, y, tint);
    
    if(attributes["checked"] == "0") {
        
        if(checkOff.get_bmp())
            checkOff.get_bmp()->blitToScreen(x, y, tint);
    }
    else if(checkOn.get_bmp())
            checkOn.get_bmp()->blitToScreen(x, y, tint);
}

CheckBox::Action CheckBox::onHover()
{
    curBackground = &hover;
    
    return OK;
}

CheckBox::Action CheckBox::onLeave()
{
    curBackground = &inactive;
    
    return OK;
}

CheckBox::Action CheckBox::onClick()
{
    curBackground = &active;
    
    return OK;
}

CheckBox::Action CheckBox::onRelease()
{
    curBackground = &hover;
    
    if(attributes["checked"] == "0") {
        
        if(!attributes["checkSound"].empty())
            Sounds::play(attributes["checkSound"]);
        
        attributes["checked"] = "1";
    }
    else {
        
        if(!attributes["uncheckSound"].empty())
            Sounds::play(attributes["uncheckSound"]);
        
        attributes["checked"] = "0";
    }
    
    return OK;
}
