#include "widgets_image.h"
#include "log.h"
using namespace std;
using namespace widgets;

Image::~Image()
{
    delete anim;
}

void Image::draw(int xstart, int ystart, const Tint &tint)
{
    int x = xstart;
    int y = ystart;
    
    if(anim->get_bmp()) {
        
        if(w > 0 && h > 0 && (anim->get_bmp()->getw() != w || anim->get_bmp()->geth() != h))
            anim->get_bmp()->specialBlitToScreen(x, y, (float)w / anim->get_bmp()->getw(), (float)h / anim->get_bmp()->geth(), 0, tint);
        else
            anim->get_bmp()->blitToScreen(x, y, tint);
    }
}

void Image::load()
{
    anim = new animation(attributes["src"]);
    
    if(anim->get_bmp())
        out << "(Image): Loaded \"" << attributes["src"] << "\" successfully.\n";
    else
        out << "(Image): Failed to find \"" << attributes["src"] << "\" in datafile.\n";
    
    if(w > 0 && h > 0 && (anim->get_bmp()->getw() != w || anim->get_bmp()->geth() != h))
        out << "(Image): Using scaled drawing mode(" << (float)w / anim->get_bmp()->getw() * 100 << "%, " << (float)h / anim->get_bmp()->geth() * 100 << "%).\n";
    else
        out << "(Image): Using standard drawing mode.\n";
}
