#include "widgets_minibutton.h"
#include "print.h"
#include "log.h"
using namespace std;
using namespace widgets;

MiniButton::MiniButton()
    : inactive("GUI/MINIBUTTON/INACTIVE/"),
      active("GUI/MINIBUTTON/ACTIVE/"),
      hover("GUI/MINIBUTTON/HOVER/"),
      
      current(&inactive)
{
    
}

void MiniButton::draw(int xstart, int ystart, const Tint &tint)
{
    if(current->get_bmp())
        current->get_bmp()->blitToScreen(x + xstart, y + ystart, tint);
}

MiniButton::Action MiniButton::onHover()
{
    current = &hover;
    
    return OK;
}

MiniButton::Action MiniButton::onLeave()
{
    current = &inactive;
    
    return OK;
}

MiniButton::Action MiniButton::onClick()
{
    current = &active;
    
    return OK;
}

MiniButton::Action MiniButton::onRelease()
{
    current = &hover;
    
    return OK;
}
